# ==============================================================================
#                Separator used in uiScriptPy Lib
#  ----------------------------------------------------------------------------
#  seperator  UI script ... SEPARATOR
# (this was largely undocumented so shooting in the dark alittle) 
# ==============================================================================

from enums        import *
from base_classes import *


class SepUiScriptGadget(UiScriptGadget):

	def __init__(self, name): 

		self.setName(name)
		
		# will disappear is not set
		self.setHeight(.02)
		
		return None


	#def __repr__(self):
		#pass

	# for declaration
	_type          = uiScriptGadgetType.separator

	# specific to this gadget
	_seperator_look = None


	# specific gadget attibutes

	
	# ---------------------------------

	# access
	
	def seperatorLook(self):
	  
		'''Returns a enumeration for the look of the seperator'''
		
		return self._seperator_look
		
	# ---------------------------------
	
	# writing
	def setSeperatorLook(self, uiScriptSeparatorLook):
	  
		'''Set a enumeration for the look of the seperator'''
		
		self._seperator_look = uiScriptSeparatorLook
		return None
	      
	# ---------------------------------

	def _printDeclarations(self):

		# no value declaration as its non-interactive
		# not much going on here at actually

		# gadget declaration
		gadget_decl = self._name + '.gad ='

		gadget_decl += ' SEPARATOR'
		
		# change the look if needed
		if self._printOkay(self._seperator_look):
			gadget_decl += '(' + self._seperator_look.name() + ')'

		all_attribs = self._printAllAttributes()
		cmds        = self._printCmds()

		result = gadget_decl +' '+all_attribs+';\n'+cmds

		return result

	

	def _printGadgetAttributes(self):

		gadget_attribs = [
			          #,
			          #,
			          #
			         ]
		result = [i for i in gadget_attribs if i !=None]
		return result
