# ==============================================================================
#           scroller containers class used in uiScriptPy module
#  ----------------------------------------------------------------------------
#  scrollerc uiScriptContainer currently either for ui Script attributes
#       SCROLLER and TOOLSSCROLLER
# ==============================================================================

# deal with the type/container type, basic type etc....
# how to get the labes on here???

from   enums        import *
import utils
from   base_classes import *
from   container_class import*

class SwitcherUiScriptContainer(UiScriptContainer):



	def __init__(self, name, uiScriptGadgets=(), tight=False ):

		self._name           = name
		self._children       = uiScriptGadgets ## all gadget are valid so no need to check types
		self._container_type = uiScriptContainerType.switcher
		self._tight          = tight
		#self._label          = name
		
		#if not label: self._label = self._name # label is opt, but as convention...

		return None
		
	# for declaration
	_children       = ()
	_switcher_type  = None               ### Need to find out what these are ****
	_container_type = uiScriptContainerType.scroller
	_type           = uiScriptGadgetType.container


	# specific to this gadget
	#_label        = None
	#_label_width  = None ## not sure about this
	_tight         = False
	
	# specific gadget attibutes

	# ---------------------------------
	

	#def label(self):
		#return self._label
		
	def isTight(self):
		return self._tight
	
	## ---------------------------------
	

	def setIsTight(self, true_or_false):
	  
		self._tight = bool(true_or_false)
		return None
		
	#def setLabel(self, label):
		#self._label = label
		#return None
		
	# ---------------------------------
	
	def _printDeclarations(self):
	# prints the container declaration with refs to children

		# its a switcher alright
		gadget_decl = self._name + '.gad = SWITCHER' #+ self._container_type
		
		# its a tight switcher is set as such
		if self._tight == True:
			gadget_decl += ' tight'
		
		#scroller_type = (self._scroller_type.rsplit('.', 1)[-1]).upper() ##NEED A CHECK HER TO MAKE SURE VASLID
		#gadget_decl +=  ' ' + scroller_type
		
		#if self._scroller_type == uiScriptScrollerType.scroller:
		  
			#if self._printOkay(self._direction):
			  
				#direction = self._direction.rsplit('.', 1)[-1]
				#gadget_decl += ' ' +direction
				##gadget_decl += '(' + direction  + ')'
		
		# gather any attributes set
		all_attribs = self._printAllAttributes()
		all_attribs = '    ' + all_attribs
		
		# list the gadget refs for children
		gadget_refs = [x._name + '.gad;\n' for x in self._children]
		gadget_refs_string = '    ' + ('    '.join(gadget_refs) )
		
		# munge it all together
		gadget_decl += '\n{\n' + all_attribs + '\n\n' + gadget_refs_string + '}'

		# commands
		cmds        = self._printCmds()

		# resulting string
		result = gadget_decl +'\n'+cmds
		
		return result