# ==============================================================================
#                Float used in uiScriptPy Lib
#  ----------------------------------------------------------------------------
#  Subclass of the more general num_class
#
#  Various label fields and related combines UI script ...
#     FLOAT_FIELD FLOAT_SLIDER FLOAT_SLIDER_FIELD FLOAT_VECTOR_FIELD FLOAT_SPINNER_FIELD
# ==============================================================================

from enums        import *
from base_classes import *
from num_class    import *


class FloatUiScriptGadget(NumUiScriptGadget):

	def __init__(self, name, label, vector_size=None): 

		self.setName(name)
		self.setLabel(label)
		self.setVectorSize(vector_size)
		self.setSliderRange(0,10)
		
		self._value       = 0
		self._type        = uiScriptGadgetType.float
		
		# label is opt, but as convention...
		if label == None: self.setLabel(self.name())

		return None

