# ==============================================================================
#                toggle(button) used in uiScriptPy module
#  ----------------------------------------------------------------------------
#  just a subclass of the button with toggle on by default..
#      more consistant with parmTemplates and sit logically we think of them
#      as checking something off and not a button
# ==============================================================================



from enums        import *
from base_classes import *
from button_class import *


class ToggleUiScriptGadget(ButtonUiScriptGadget):

	def __init__(self, name, label=None, icon=None): 
	  
		'''Toggle with or without icon.
		    Without Icon appears as a check box.
		    With Icon, does NOT diplay Label.
		    
		    This is a convieniance.
		    Same as a Button set to toggle'''

		self._name  = name
		self._label = label
		
		self._value   = 0
		self._type    = uiScriptGadgetType.button
		self._button_type = uiScriptButtonType.toggle
		
		# label is opt, but as convention...
		if not label: self._label = self._name
		
		# store the icon if provided
		if icon:
			self._icon = icon
			
		return None